package com.dk.mdm.service.ivt.outbound;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.dk.common.exception.BaseBusinessException;
import com.dk.common.infrastructure.annotaiton.Pagination;
import com.dk.common.infrastructure.constant.Constant;
import com.dk.common.infrastructure.enums.ErrorCodeEnum;
import com.dk.common.mapper.BaseMapper;
import com.dk.common.model.pojo.PageList;
import com.dk.common.response.ResponseCodeEnum;
import com.dk.common.response.ResponseResultUtil;
import com.dk.common.response.ResponseResultVO;
import com.dk.common.service.BaseService;
import com.dk.mdm.infrastructure.convert.ivt.OutboundConvert;
import com.dk.mdm.infrastructure.convert.ivt.OutboundItemConvert;
import com.dk.mdm.mapper.common.CommonMapper;
import com.dk.mdm.mapper.ivt.OutboundItemMapper;
import com.dk.mdm.mapper.ivt.OutboundMapper;
import com.dk.mdm.mapper.mst.CustomerMapper;
import com.dk.mdm.mapper.sale.MultiOwnerMapper;
import com.dk.mdm.mapper.sale.OrderItemMapper;
import com.dk.mdm.mapper.sale.OrderMapper;
import com.dk.mdm.model.pojo.ivt.Outbound;
import com.dk.mdm.model.pojo.ivt.OutboundItem;
import com.dk.mdm.model.pojo.mst.Customer;
import com.dk.mdm.model.pojo.pur.PurchaseItem;
import com.dk.mdm.model.pojo.sale.MultiOwner;
import com.dk.mdm.model.pojo.sale.Order;
import com.dk.mdm.model.pojo.sale.OrderItem;
import com.dk.mdm.model.query.ivt.OutboundItemQuery;
import com.dk.mdm.model.query.ivt.OutboundQuery;
import com.dk.mdm.model.query.sale.OrderQuery;
import com.dk.mdm.model.response.ivt.OutboundItemResponse;
import com.dk.mdm.model.response.ivt.OutboundResponse;
import com.dk.mdm.model.response.sale.OrderItemResponse;
import com.dk.mdm.model.response.sale.OrderResponse;
import com.dk.mdm.model.vo.ivt.InboundItemVO;
import com.dk.mdm.model.vo.ivt.OutboundItemVO;
import com.dk.mdm.model.vo.ivt.OutboundVO;
import com.dk.mdm.service.common.CommonService;
import com.dk.mdm.service.ivt.inventory.InventoryService;
import com.dk.mdm.service.mac.AccountService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;


/**
 * @author : 寇珊珊
 * @desc : 销售出库业务层
 * @date : 2024/3/18 15:33
 */
@Service
public class OutboundSaleOrderService extends BaseService<Outbound> {

    @Override
    public BaseMapper<Outbound> getRepository() {
        return outboundMapper;
    }

    @Autowired
    private CommonService commonService;

    @Autowired
    private OutboundMapper outboundMapper;

    @Autowired
    private OutboundConvert outboundConvert;

    @Autowired
    private OutboundItemMapper outboundItemMapper;

    @Autowired
    private OutboundItemConvert outboundItemConvert;

    @Autowired
    private OrderMapper orderMapper;

    @Autowired
    private OrderItemMapper orderItemMapper;

    @Autowired
    private CommonMapper commonMapper;

    @Autowired
    private InventoryService inventoryService;

    @Autowired
    private AccountService accountService;

    @Autowired
    private OutCommon outCommon;


    /**
     * @desc : 销售出库新建
     * @date : 2024/3/7 14:13
     * @author : 寇珊珊
     */
    @Transactional(rollbackFor = {Exception.class})
    public ResponseResultVO<?> saleOrderOutboundInsert(OutboundVO outboundVO) {
        //region 如果没有客户id，要新建
        if (outboundVO.getCusId() == null) {
            outboundVO = outCommon.insertCustomer(outboundVO);
        }
        //endregion

        //region  查询当前公司的系统参数  自动办理信息  并赋值
        Map<String, Object> map = new HashMap<>();
        map.put("cpId", outboundVO.getCpId());
        map.put("code", Constant.SystemConstant.IVT_001.getValue());
        //自动办理标识
        String flgHandleSetting = commonMapper.getSettingValue(map);
        //自动办理标识为1 自动办理入库
        if (Constant.FlgAutoHandleStringType.ONE.getValue().equals(flgHandleSetting)) {
            outboundVO.setFlgHandleSetting(Constant.FlgHandleSetting.TRUE.getValue());
            outboundVO.setFlgAutoHandle(Constant.FlgAutoHandle.TRUE.getValue());
        }
        //endregion

        //region  总单
        //获取 id/单号
        Map<String, Object> codeMap = commonService.getUniqueNoteCode(Constant.docNameConstant.SALEORDER.getName(), false);
        outboundVO.setOutId(codeMap.get("outId").toString()).
                setOutNo(codeMap.get("outNote").toString());
        //出库类型
        outboundVO.setOutType(Constant.OutType.SALE.getName());
        //自动入库标识
        if (outboundVO.getFlgAutoHandle()) {
            //已出库
            outboundVO.setOutStatus(Constant.OutStatus.YICHUKU.getName());
        } else {
            //出库中
            outboundVO.setOutStatus(Constant.OutStatus.CHUKUZHONG.getName());
        }
        //出库状态等于已出库 更新合计出库数量/金额 = 出库中数量/出库中金额
        if (Constant.OutStatus.YICHUKU.getName().equals(outboundVO.getOutStatus())) {
            outboundVO
                    .setOutQty(outboundVO.getOutingQty())
                    .setOutAmt(outboundVO.getOutingAmt())
                    .setOutingQty(BigDecimal.ZERO)
                    .setOutingAmt(BigDecimal.ZERO)
            ;
        } else {
            outboundVO
                    .setOutQty(BigDecimal.ZERO)
                    .setOutAmt(BigDecimal.ZERO)
            ;
        }

        //实体转换
        Outbound outbound = outboundConvert.convertToPo(outboundVO);
        outboundMapper.insert(outbound);
        //endregion

        //region  新建多业务归属
        outCommon.insertMultiOwner(outboundVO);
        //endregion

        //region 销售订单
        if (outboundVO.getFromId() != null) {
            //赋值  （这里重写了更新方法，数量在更新方法中有数据库院士数量+本次数量）
            Order order = new Order();
            order.setOrderId(outboundVO.getFromId());
            //根据id查询
            OrderResponse orderResponse = orderMapper.selectById(outboundVO.getFromId());
            //已出库
            if (Constant.OutStatus.YICHUKU.getName().equals(outboundVO.getOutStatus())) {
                order.setOutingQty(BigDecimal.ZERO);
                order.setOutingAmt(BigDecimal.ZERO);
                order.setOutQty(outboundVO.getOutQty());
                order.setOutAmt(outboundVO.getOutAmt());
            }
            //出库中
            else {
                order.setOutingQty(outboundVO.getOutingQty());
                order.setOutingAmt(outboundVO.getOutingAmt());
                order.setOutQty(BigDecimal.ZERO);
                order.setOutAmt(BigDecimal.ZERO);
            }
            //入库状态
            String outStatus = this.setOutStatus(orderResponse.getOutingQty().add(order.getOutingQty()),
                    orderResponse.getOutQty().add(order.getOutQty()), orderResponse.getSumQuantity());
            order.setOutStatus(outStatus);
            //修改
            int countRow = orderMapper.updateById(order);
            //数量超出
            if (countRow == 0) {
                throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
            }
        }
        //endregion

        //region 明细
        //校验明细
        if (outboundVO.getItemList().size() == 0) {
            throw new BaseBusinessException(ErrorCodeEnum.OUTBOUND_ITEM_NOT_EXIST.getCode(),
                    ErrorCodeEnum.OUTBOUND_ITEM_NOT_EXIST.getMessage());
        }
        for (OutboundItemVO outboundItemVO : outboundVO.getItemList()) {

            //region 将库存需要的参数赋值
            outboundItemVO.setInventoryType(Constant.InventoryType.OUTBOUND.getName());
            outboundItemVO.setInventoryDocCode(Constant.InventoryDocCode.SALE_ORDER.getValue());
            outboundItemVO.setAddOrEditFlag(true);
            //endregion

            //总单id
            outboundItemVO.setOutId(outboundVO.getOutId());
            //出库类型
            outboundItemVO.setOutType(outboundVO.getOutType());
            //出库状态等于已出库  更新合计出库数量/金额 = 出库中数量/出库中金额
            if (Constant.OutStatus.YICHUKU.getName().equals(outboundVO.getOutStatus())) {
                outboundItemVO
                        .setOutQty(outboundItemVO.getOutingQty())
                        .setOutAmt(outboundItemVO.getOutingAmt())
                        .setOutingQty(BigDecimal.ZERO)
                        .setOutingAmt(BigDecimal.ZERO)
                        .setCostPrice(outboundItemVO.getPriceOut())
                        .setCostAmt(outboundItemVO.getOutQty().multiply(outboundItemVO.getPriceOut()).setScale(2, BigDecimal.ROUND_HALF_UP))
                ;
            } else {
                outboundItemVO
                        .setOutQty(BigDecimal.ZERO)
                        .setOutAmt(BigDecimal.ZERO);
            }
            //入库状态
            outboundItemVO.setOutStatus(outboundVO.getOutStatus());
            //实体转换
            OutboundItem outboundItem = outboundItemConvert.convertToPo(outboundItemVO);
            outboundItemMapper.insert(outboundItem);
            outboundItemVO.setItemId(outboundItem.getItemId());
            //endregion

            //region 销售明细
            if (outboundItemVO.getFromItemId() != null) {
                //赋值 （这里重写了更新方法，数量在更新方法中有数据库院士数量+本次数量）
                OrderItem orderItem = new OrderItem();
                orderItem.setItemId(outboundItemVO.getFromItemId());
                //根据id查询
                OrderItemResponse orderItemResponse = orderItemMapper.selectById(outboundItemVO.getFromItemId());
                //已出库
                if (Constant.OutStatus.YICHUKU.getName().equals(outboundVO.getOutStatus())) {
                    orderItem.setOutingQty(BigDecimal.ZERO);
                    orderItem.setOutingAmt(BigDecimal.ZERO);
                    orderItem.setOutQty(outboundItemVO.getOutQty());
                    orderItem.setOutAmt(outboundItemVO.getOutAmt());
                }
                //出库中
                else {
                    orderItem.setOutingQty(outboundItemVO.getOutingQty());
                    orderItem.setOutingAmt(outboundItemVO.getOutingAmt());
                    orderItem.setOutQty(BigDecimal.ZERO);
                    orderItem.setOutAmt(BigDecimal.ZERO);
                }
                //入库状态
                String outStatus = this.setOutStatus(orderItemResponse.getOutingQty().add(orderItem.getOutingQty()),
                        orderItemResponse.getOutQty().add(orderItem.getOutQty()), orderItemResponse.getItemQty());
                orderItem.setOutStatus(outStatus);
                //修改
                int countRow = orderItemMapper.updateById(orderItem);
                //数量超出
                if (countRow == 0) {
                    throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                }
            }
            //endregion

        }
        //endregion

        //region  已出库  应收记账
        if (Constant.OutStatus.YICHUKU.getName().equals(outboundVO.getOutStatus())) {
            accountService.accReceivable(outboundVO.getOutId(), Constant.InventoryDocCode.OUTBOUND.getTableName());
        }
        //endregion

        //region 库存
        if(Constant.OutStatus.YICHUKU.getName().equals(outboundVO.getOutStatus())){
            Map<String, Object> invMap = new HashMap<>();
            invMap.put("outDetail",outboundVO.getItemList());
            inventoryService.operatingInventoryInformation(invMap);
        }
        //endregion

        return ResponseResultUtil.success(outboundVO);
    }

    /**
     * @desc : 销售出库编辑
     * @date : 2024/3/25 16:25
     * @author : 寇珊珊
     */
    @Transactional(rollbackFor = {Exception.class})
    public ResponseResultVO<?> saleOutboundUpdate(OutboundVO outboundVO) {
        //region 小编辑
        if (!outboundVO.getLimitEdit()) {
            Outbound outbound = new Outbound();
            outbound.setOutId(outboundVO.getOutId());
            outbound.setRemarks(outboundVO.getRemarks());
            outbound.setAnnexPaths(outboundVO.getAnnexPaths());
            outboundMapper.update(outbound,
                    new UpdateWrapper<Outbound>().lambda()
                            .eq(Outbound::getOutId, UUID.fromString(outbound.getOutId()))
            );
            for (OutboundItemVO outboundItemVO : outboundVO.getItemList()) {
                OutboundItem outboundItem = new OutboundItem();
                outboundItem.setItemId(outboundItemVO.getItemId());
                if(outboundItemVO.getRemarks() != null || outboundItemVO.getRemarks()!=" "){
                    outboundItem.setRemarks(outboundItemVO.getRemarks());
                    outboundItemMapper.update(outboundItem,
                            new UpdateWrapper<OutboundItem>().lambda()
                                    .eq(OutboundItem::getItemId, UUID.fromString(outboundItem.getItemId()))
                    );
                }
            }
        }
        //endregion
        //region 大编辑
        else {
            //region 根据id查询   并且明细数量金额  求和
            OutboundResponse outboundResponse = outboundMapper.selectById(outboundVO.getOutId());
            BigDecimal sumQty = outboundVO.getItemList().stream().map(OutboundItemVO::getOutingQty).reduce(BigDecimal.ZERO, BigDecimal::add).setScale(6, BigDecimal.ROUND_HALF_UP);
            BigDecimal sumAmt = outboundVO.getItemList().stream().map(OutboundItemVO::getOutingAmt).reduce(BigDecimal.ZERO, BigDecimal::add).setScale(2, BigDecimal.ROUND_HALF_UP);
            //endregion

            //region  自动办理参数为true  已入库编辑
            //自动办理参数为true
            if (Constant.FlgHandleSetting.TRUE.getValue().equals(outboundVO.getFlgHandleSetting())) {
                //region 应收反记账
                if (outboundVO.getReceivableId() != null) {
                    accountService.reverseReceivable(outboundVO.getOutId(), Constant.InventoryDocCode.OUTBOUND.getTableName());
                }
                //endregion

                //region 修改明细
                List<OutboundItemVO> itemList = outboundVO.getItemList();
                for (OutboundItemVO outboundItemVO : itemList) {
                    //根据id查询
                    OutboundItemResponse outboundItemResponse = outboundItemMapper.selectById(outboundItemVO.getItemId());

                    //region  编辑明细
                    if (outboundItemVO.getItemId() != null) {

                        //region 将库存需要的参数赋值
                        outboundItemVO.setInventoryType(Constant.InventoryType.OUTBOUND.getName());
                        outboundItemVO.setInventoryDocCode(Constant.InventoryDocCode.SALE_ORDER.getValue());
                        //编辑之前的数
                        outboundItemVO.setQtyBeforeUpdate(outboundItemResponse.getOutQty());
                        outboundItemVO.setAmtBeforeUpdate(outboundItemResponse.getOutAmt());
                        //编辑之后的数
                        outboundItemVO.setOutQty(outboundItemVO.getOutingQty());
                        outboundItemVO.setOutAmt(outboundItemVO.getOutingAmt());
                        outboundItemVO.setAddOrEditFlag(false);
                        //endregion
                        
                        OutboundItem outboundItem = new OutboundItem();
                        outboundItem.setItemId(outboundItemVO.getItemId());
                        outboundItem.setOutQty(outboundItemVO.getOutingQty());
                        outboundItem.setOutAmt(outboundItemVO.getOutingAmt());
                        outboundItem.setCostPrice(outboundItemVO.getPriceOut());
                        outboundItem.setCostAmt(outboundItemVO.getOutQty().multiply(outboundItemVO.getPriceOut()).setScale(6, BigDecimal.ROUND_HALF_UP));
                        //修改
                        outboundItemMapper.update(outboundItem,
                                new UpdateWrapper<OutboundItem>().lambda()
                                        .eq(OutboundItem::getItemId, UUID.fromString(outboundItem.getItemId()))
                        );
                    }
                    //endregion

                    //region 新建明细
                    else {
                        outboundItemVO
                                .setOutId(outboundItemVO.getOutId())
                                .setOutQty(outboundItemVO.getOutingQty())
                                .setOutAmt(outboundItemVO.getOutingAmt())
                                .setOutingQty(BigDecimal.ZERO)
                                .setOutingAmt(BigDecimal.ZERO)
                                .setCostPrice(outboundItemVO.getPriceOut())
                                .setCostAmt(outboundItemVO.getOutQty().multiply(outboundItemVO.getPriceOut()).setScale(2, BigDecimal.ROUND_HALF_UP))
                                .setOutType(Constant.OutType.SALE.getName())
                        ;
                        //出库状态
                        String outStatus = this.setOutStatus(outboundItemVO.getOutingQty(), outboundItemVO.getOutQty());
                        outboundItemVO.setOutStatus(outStatus);
                        //实体转换
                        OutboundItem outboundItem = outboundItemConvert.convertToPo(outboundItemVO);
                        //新建
                        outboundItemMapper.insert(outboundItem);
                        outboundItemVO.setItemId(outboundItem.getItemId());
                        //region 将库存需要的参数赋值
                        outboundItemVO.setInventoryType(Constant.InventoryType.OUTBOUND.getName());
                        outboundItemVO.setInventoryDocCode(Constant.InventoryDocCode.SALE_ORDER.getValue());
                        outboundItemVO.setAddOrEditFlag(true);
                        //endregion
                    }
                    //endregion

                    //region  销售明细
                    if (outboundItemVO.getFromItemId() != null) {
                        //根据id查询
                        OrderItemResponse orderItemResponse = orderItemMapper.selectById(outboundItemVO.getFromItemId());
                        OrderItem orderItem = new OrderItem();
                        orderItem.setItemId(outboundItemVO.getFromItemId());
                        orderItem.setOutQty(outboundItemResponse.getOutQty().negate().add(outboundItemVO.getOutingQty()));
                        orderItem.setOutAmt(outboundItemResponse.getOutAmt().negate().add(outboundItemVO.getOutingAmt()));
                        orderItem.setOutingQty(outboundItemVO.getOutQty());
                        orderItem.setOutingAmt(outboundItemVO.getOutAmt());
                        //出库状态
                        String outStatus = this.setOutStatus(orderItemResponse.getOutingQty().add(orderItem.getOutingQty()),
                                orderItemResponse.getOutQty().add(orderItem.getOutQty()), orderItemResponse.getItemQty());
                        orderItem.setOutStatus(outStatus);
                        int countRow = orderItemMapper.updateById(orderItem);
                        //数量超出
                        if (countRow == 0) {
                            throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                        }
                    }
                    //endregion
                }
                //endregion

                //region 删除明细
                BigDecimal delOutQty = BigDecimal.ZERO;
                BigDecimal delOutAmt = BigDecimal.ZERO;
                if (outboundVO.getDeleteItemList() != null && outboundVO.getDeleteItemList().size() > 0) {
                    delOutQty = outboundVO.getDeleteItemList().stream().map(OutboundItemVO::getOutQty).reduce(BigDecimal.ZERO, BigDecimal::add).setScale(6, BigDecimal.ROUND_HALF_UP);
                    delOutAmt = outboundVO.getDeleteItemList().stream().map(OutboundItemVO::getOutAmt).reduce(BigDecimal.ZERO, BigDecimal::add).setScale(2, BigDecimal.ROUND_HALF_UP);
                    for (OutboundItemVO outboundItemVO : outboundVO.getDeleteItemList()) {
                        if (outboundItemVO.getItemId() != null) {
                            //region 将库存需要的参数赋值
                            outboundItemVO.setInventoryType(Constant.InventoryType.OUTBOUND.getName());
                            outboundItemVO.setInventoryDocCode(Constant.InventoryDocCode.SALE_ORDER.getValue());
                            //endregion
                            OutboundItem outboundItem = outboundItemConvert.convertToPo(outboundItemVO);
                            outboundItem.setFlgValid(false);
                            //修改
                            outboundItemMapper.update(outboundItem,
                                    new UpdateWrapper<OutboundItem>().lambda()
                                            .eq(OutboundItem::getItemId, UUID.fromString(outboundItem.getItemId()))
                            );
                        }
                        //region  销售明细
                        if (outboundItemVO.getFromItemId() != null) {
                            //根据id查询
                            OrderItemResponse orderItemResponse = orderItemMapper.selectById(outboundItemVO.getFromItemId());
                            OrderItem orderItem = new OrderItem();
                            orderItem.setItemId(outboundItemVO.getFromItemId());
                            orderItem.setOutQty(outboundItemVO.getOutQty().negate());
                            orderItem.setOutAmt(outboundItemVO.getOutAmt().negate());
                            orderItem.setOutingQty(outboundItemVO.getOutQty());
                            orderItem.setOutingAmt(outboundItemVO.getOutQty());
                            //出库状态
                            String outStatus = this.setOutStatus(orderItemResponse.getOutingQty().add(orderItem.getOutingQty()),
                                    orderItemResponse.getOutQty().add(orderItem.getOutQty()), orderItemResponse.getItemQty());
                            orderItem.setOutStatus(outStatus);
                            int countRow = orderItemMapper.updateById(orderItem);
                            //数量超出
                            if (countRow == 0) {
                                throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                            }
                        }
                        //endregion
                    }
                }
                //endregion

                //region  修改出库总单
                Outbound outbound = new Outbound();
                outbound.setOutId(outboundVO.getOutId());
                outbound.setOutQty(sumQty);
                outbound.setOutAmt(sumAmt);
                //修改
                outboundMapper.update(outbound,
                        new UpdateWrapper<Outbound>().lambda().eq(Outbound::getOutId, UUID.fromString(outbound.getOutId()))
                );
                //endregion

                //region 修改销售总单
                if (outboundVO.getFromId() != null) {
                    //根据id查询
                    OrderResponse orderResponse = orderMapper.selectById(outboundVO.getFromId());
                    Order order = new Order();
                    order.setOrderId(outboundVO.getFromId());
                    order.setOutQty(outboundResponse.getOutQty().negate().add(sumQty).subtract(delOutQty));
                    order.setOutAmt(outboundResponse.getOutAmt().negate().add(sumAmt).subtract(delOutAmt));
                    order.setOutingQty(delOutQty);
                    order.setOutingAmt(delOutAmt);
                    //出库状态
                    String outStatus = this.setOutStatus(orderResponse.getOutingQty().add(order.getOutingQty()),
                            orderResponse.getOutQty().add(order.getOutQty()), orderResponse.getSumQuantity());
                    order.setOutStatus(outStatus);
                    //修改
                    int countRow = orderMapper.updateById(order);
                    //数量超出
                    if (countRow == 0) {
                        throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                    }
                }
                //endregion

                //region  应收记账
                if (outboundVO.getReceivableId() != null) {
                    accountService.accReceivable(outboundResponse.getOutId(), Constant.InventoryDocCode.OUTBOUND.getTableName());
                }
                //endregion

                //region 修改库存
                Map<String, Object> invMap = new HashMap<>();
                invMap.put("outDetail", outboundVO.getItemList());
                invMap.put("delOutDetail", outboundVO.getDeleteItemList());
                inventoryService.operatingInventoryInformation(invMap);
                //endregion
            }
            else{
                throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.FLG_HANDLE_SETTING_NOT_ENABLED_OUT.getMessage());
            }
            //endregion

            //region 自动办理参数false  入库中编辑
            //自动办理标识为false 并且 自动办理参数为false  入库中
            if (!outboundVO.getFlgAutoHandle() && Constant.FlgHandleSetting.FALSE.getValue().equals(outboundVO.getFlgHandleSetting())) {
                //region 修改明细
                List<OutboundItemVO> itemList = outboundVO.getItemList();
                for (OutboundItemVO outboundItemVO : itemList) {

                    //根据id查询 获取到还未进行修改的数据
                    OutboundItemResponse outboundItemResponse = outboundItemMapper.selectById(outboundItemVO.getItemId());

                    //region 编辑明细
                    if (outboundItemVO.getItemId() != null) {
                        OutboundItem outboundItem = new OutboundItem();
                        outboundItem.setItemId(outboundItemResponse.getItemId());
                        outboundItem.setOutingQty(outboundItemResponse.getOutingQty());
                        outboundItem.setOutingAmt(outboundItemResponse.getOutingAmt());
                        //修改
                        outboundItemMapper.update(outboundItem,
                                new UpdateWrapper<OutboundItem>().lambda()
                                        .eq(OutboundItem::getItemId, UUID.fromString(outboundItem.getItemId()))
                        );
                    }
                    //endregion

                    //region 新建明细
                    else {
                        outboundItemVO
                                .setOutId(outboundItemVO.getOutId())
                                .setOutQty(BigDecimal.ZERO)
                                .setOutAmt(BigDecimal.ZERO)
                                .setCostPrice(outboundItemVO.getPriceOut())
                                .setCostAmt(outboundItemVO.getOutingQty().multiply(outboundItemVO.getPriceOut()).setScale(2, BigDecimal.ROUND_HALF_UP))
                                .setOutType(Constant.OutType.SALE.getName())
                        ;
                        //出库状态
                        String outStatus = this.setOutStatus(outboundItemVO.getOutingQty(), outboundItemVO.getOutQty());
                        outboundItemVO.setOutStatus(outStatus);
                        //实体转换
                        OutboundItem outboundItem = outboundItemConvert.convertToPo(outboundItemVO);
                        //新建
                        outboundItemMapper.insert(outboundItem);
                        outboundItemVO.setItemId(outboundItem.getItemId());
                    }
                    //endregion

                    //region  销售明细
                    if (outboundItemVO.getFromItemId() != null) {
                        //根据id查询
                        OrderItemResponse orderItemResponse = orderItemMapper.selectById(outboundItemVO.getFromItemId());
                        OrderItem orderItem = new OrderItem();
                        orderItem.setItemId(outboundItemVO.getFromItemId());
                        orderItem.setOutingQty(outboundItemResponse.getOutingQty().negate().add(outboundItemVO.getOutingQty()));
                        orderItem.setOutingAmt(outboundItemResponse.getOutingAmt().negate().add(outboundItemVO.getOutingAmt()));
                        //出库状态
                        String outStatus = this.setOutStatus(orderItemResponse.getOutingQty().add(orderItem.getOutingQty()),
                                orderItemResponse.getOutQty(), orderItemResponse.getItemQty());
                        orderItem.setOutStatus(outStatus);
                        int countRow = orderItemMapper.updateById(orderItem);
                        //数量超出
                        if (countRow == 0) {
                            throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                        }
                    }
                    //endregion
                }
                //endregion

                //region 删除明细
                BigDecimal delOutQty = BigDecimal.ZERO;
                BigDecimal delOutAmt = BigDecimal.ZERO;
                if (outboundVO.getDeleteItemList() != null && outboundVO.getDeleteItemList().size() > 0) {
                    delOutQty = outboundVO.getDeleteItemList().stream().map(OutboundItemVO::getOutingQty).reduce(BigDecimal.ZERO, BigDecimal::add).setScale(6, BigDecimal.ROUND_HALF_UP);
                    delOutAmt = outboundVO.getDeleteItemList().stream().map(OutboundItemVO::getOutingAmt).reduce(BigDecimal.ZERO, BigDecimal::add).setScale(2, BigDecimal.ROUND_HALF_UP);
                    for (OutboundItemVO outboundItemVO : outboundVO.getDeleteItemList()) {
                        if (outboundItemVO.getItemId() != null) {
                            OutboundItem outboundItem = outboundItemConvert.convertToPo(outboundItemVO);
                            outboundItem.setFlgValid(false);
                            //修改
                            outboundItemMapper.update(outboundItem,
                                    new UpdateWrapper<OutboundItem>().lambda()
                                            .eq(OutboundItem::getItemId, UUID.fromString(outboundItem.getItemId()))
                            );
                        }
                        //region  销售明细
                        if (outboundItemVO.getFromItemId() != null) {
                            //根据id查询
                            OrderItemResponse orderItemResponse = orderItemMapper.selectById(outboundItemVO.getFromItemId());
                            OrderItem orderItem = new OrderItem();
                            orderItem.setItemId(outboundItemVO.getFromItemId());
                            orderItem.setOutingQty(outboundItemVO.getOutQty().negate());
                            orderItem.setOutingAmt(outboundItemVO.getOutQty().negate());
                            //出库状态
                            String outStatus = this.setOutStatus(orderItemResponse.getOutingQty().add(orderItem.getOutingQty()),
                                    orderItemResponse.getOutQty(), orderItemResponse.getItemQty());
                            orderItem.setOutStatus(outStatus);
                            int countRow = orderItemMapper.updateById(orderItem);
                            //数量超出
                            if (countRow == 0) {
                                throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                            }
                        }
                        //endregion
                    }
                }
                //endregion

                //region  修改入库总单
                Outbound outbound = new Outbound();
                outbound.setOutId(outboundVO.getOutId());
                outbound.setOutingQty(sumQty);
                outbound.setOutingAmt(sumAmt);
                //修改
                outboundMapper.update(outbound,
                        new UpdateWrapper<Outbound>().lambda().eq(Outbound::getOutId, UUID.fromString(outbound.getOutId()))
                );
                //endregion

                //region 修改采购总单
                if (outboundVO.getFromId() != null) {
                    //根据id查询
                    OrderResponse orderResponse = orderMapper.selectById(outboundVO.getFromId());
                    Order order = new Order();
                    order.setOrderId(outboundVO.getFromId());
                    order.setOutingQty(outboundResponse.getOutingQty().negate().add(sumQty).subtract(delOutQty));
                    order.setOutingAmt(outboundResponse.getOutingAmt().negate().add(sumAmt).subtract(delOutAmt));
                    //出库状态
                    String outStatus = this.setOutStatus(orderResponse.getOutingQty().add(order.getOutingQty()),
                            orderResponse.getOutQty(), orderResponse.getSumQuantity());
                    order.setOutStatus(outStatus);
                    //修改
                    int countRow = orderMapper.updateById(order);
                    //数量超出
                    if (countRow == 0) {
                        throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                    }
                }
                //endregion
            }
            else{
                throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.FLG_HANDLE_SETTING_NOT_ENABLED_OUT.getMessage());
            }
            //endregion
        }
        //endregion
        return ResponseResultUtil.success(outboundVO);
    }

    /**
     * @desc : 销售出库作废
     * @date : 2024/3/26 9:24
     * @author : 寇珊珊
     */
    @Transactional(rollbackFor = {Exception.class})
    public ResponseResultVO<?> saleOutboundRepeal(String outId) {
        //region  查询总单  查询明细
        //根据id查询 此条出库单的数据还未更改前的数据
        OutboundResponse outboundResponse = outboundMapper.selectById(outId);
        //根据总单id查询
        List<OutboundItemResponse> outboundItemResponseList = outboundItemMapper.selectByCond(new OutboundItemQuery().setOutId(outboundResponse.getOutId()));

        //endregion

        //region  自动办理参数为true  已入库编辑
        //自动办理参数为true
        if (Constant.FlgHandleSetting.TRUE.getValue().equals(outboundResponse.getFlgHandleSetting())) {
            //region 应收反记账
            if (outboundResponse.getReceivableId() != null) {
                accountService.reverseReceivable(outboundResponse.getOutId(), Constant.InventoryDocCode.OUTBOUND.getTableName());
            }
            //endregion

            //region 修改明细
            for (OutboundItemResponse outboundItemResponse : outboundItemResponseList) {
                //region 将库存需要的参数赋值
                outboundItemResponse.setInventoryType(Constant.InventoryType.OUTBOUND.getName());
                outboundItemResponse.setInventoryDocCode(Constant.InventoryDocCode.SALE_ORDER.getValue());
                outboundItemResponse.setOutQty(outboundItemResponse.getOutQty().negate());
                outboundItemResponse.setOutAmt(outboundItemResponse.getOutAmt().negate());
                //endregion

                //赋值
                OutboundItem outboundItem = new OutboundItem();
                outboundItem.setItemId(outboundItemResponse.getItemId());
                outboundItem.setFlgValid(false);
                //修改
                outboundItemMapper.update(outboundItem,
                        new UpdateWrapper<OutboundItem>().lambda()
                                .eq(OutboundItem::getItemId, UUID.fromString(outboundItem.getItemId()))
                );

                //region  销售明细
                if (outboundItemResponse.getFromItemId() != null) {
                    //根据id查询
                    OrderItemResponse orderItemResponse = orderItemMapper.selectById(outboundItemResponse.getFromItemId());
                    OrderItem orderItem = new OrderItem();
                    orderItem.setItemId(outboundItemResponse.getFromItemId());
                    orderItem.setOutQty(outboundItemResponse.getOutQty().negate());
                    orderItem.setOutAmt(outboundItemResponse.getOutAmt().negate());
                    //出库状态
                    String orderOutStatus = this.setOutStatus(orderItemResponse.getOutingQty(),
                            orderItemResponse.getOutQty().add(orderItem.getOutQty()), orderItemResponse.getItemQty());
                    orderItem.setOutStatus(orderOutStatus);
                    int countRow = orderItemMapper.updateById(orderItem);
                    //数量超出
                    if (countRow == 0) {
                        throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                    }
                }
                //endregion
            }
            //endregion

            //region  修改入库总单
            Outbound outbound = new Outbound();
            outbound.setOutId(outboundResponse.getOutId());
            outbound.setFlgValid(false);
            //修改
            outboundMapper.update(outbound,
                    new UpdateWrapper<Outbound>().lambda().eq(Outbound::getOutId, UUID.fromString(outbound.getOutId()))
            );
            //endregion

            //region 修改销售总单
            if (outboundResponse.getFromId() != null) {
                //根据id查询
                OrderResponse orderResponse = orderMapper.selectById(outboundResponse.getFromId());
                Order order = new Order();
                order.setOrderId(outboundResponse.getFromId());
                order.setOutQty(outboundResponse.getOutQty().negate());
                order.setOutAmt(outboundResponse.getOutAmt().negate());
                //出库状态
                String orderOutStatus = this.setOutStatus(orderResponse.getOutingQty(),
                        orderResponse.getOutQty().add(order.getOutQty()), orderResponse.getSumQuantity());
                order.setOutStatus(orderOutStatus);
                //修改
                int countRow = orderMapper.updateById(order);
                //数量超出
                if (countRow == 0) {
                    throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                }
            }

            //endregion

            //region  修改库存
            Map<String, Object> map = new HashMap<>();
            map.put("delOutDetail", outboundItemResponseList);
            inventoryService.operatingInventoryInformation(map);
            //endregion
        }
        else{
            throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.FLG_HANDLE_SETTING_NOT_ENABLED_OUT.getMessage());
        }
        //endregion

        //region 自动办理参数false  入库中编辑
        //自动办理标识为false 并且 自动办理参数为false  入库中
        if (!outboundResponse.getFlgAutoHandle() && Constant.FlgHandleSetting.FALSE.getValue().equals(outboundResponse.getFlgHandleSetting())) {
            //region 修改明细
            for (OutboundItemResponse outboundItemResponse : outboundItemResponseList) {
                //region 修改明细
                //赋值
                OutboundItem outboundItem = new OutboundItem();
                outboundItem.setItemId(outboundItemResponse.getItemId());
                outboundItem.setOutingQty(BigDecimal.ZERO);
                outboundItem.setOutingAmt(BigDecimal.ZERO);
                outboundItem.setFlgValid(false);
                //修改
                outboundItemMapper.update(outboundItem,
                        new UpdateWrapper<OutboundItem>().lambda()
                                .eq(OutboundItem::getItemId, UUID.fromString(outboundItem.getItemId()))
                );
                //endregion

                //region  销售明细
                if (outboundItemResponse.getFromItemId() != null) {
                    //根据id查询
                    OrderItemResponse orderItemResponse = orderItemMapper.selectById(outboundItemResponse.getFromItemId());
                    OrderItem orderItem = new OrderItem();
                    orderItem.setItemId(outboundItemResponse.getFromItemId());
                    orderItem.setOutingQty(outboundItemResponse.getOutingQty().negate());
                    orderItem.setOutingAmt(outboundItemResponse.getOutingAmt().negate());
                    //出库状态
                    String orderOutStatus = this.setOutStatus(orderItemResponse.getOutingQty().add(orderItem.getOutingQty()),
                            orderItemResponse.getOutQty(), orderItemResponse.getItemQty());
                    orderItem.setOutStatus(orderOutStatus);
                    int countRow = orderItemMapper.updateById(orderItem);
                    //数量超出
                    if (countRow == 0) {
                        throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                    }
                }
                //endregion
            }
            //endregion

            //region  修改出库总单
            Outbound outbound = new Outbound();
            outbound.setOutId(outboundResponse.getOutId());
            outbound.setOutingQty(BigDecimal.ZERO);
            outbound.setOutingAmt(BigDecimal.ZERO);
            outbound.setFlgValid(false);
            //修改
            outboundMapper.update(outbound,
                    new UpdateWrapper<Outbound>().lambda().eq(Outbound::getOutId, UUID.fromString(outbound.getOutId()))
            );
            //endregion

            //region 修改销售总单
            if (outboundResponse.getFromId() != null) {
                //根据id查询
                OrderResponse orderResponse = orderMapper.selectById(outboundResponse.getFromId());
                Order order = new Order();
                order.setOrderId(outboundResponse.getFromId());
                order.setOutingQty(outboundResponse.getOutingQty().negate());
                order.setOutingAmt(outboundResponse.getOutingAmt().negate());
                //出库状态
                String orderOutStatus = this.setOutStatus(orderResponse.getOutingQty().add(order.getOutingQty()),
                        orderResponse.getOutQty(), orderResponse.getSumQuantity());
                order.setOutStatus(orderOutStatus);
                //修改
                int countRow = orderMapper.updateById(order);
                //数量超出
                if (countRow == 0) {
                    throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                }
            }
            //endregion
        }
        else{
            throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.FLG_HANDLE_SETTING_NOT_ENABLED_OUT.getMessage());
        }
        //endregion

        return ResponseResultUtil.success();
    }


    /**
     * @desc : 销售出库办理
     * @date : 2024/3/7 15:47
     * @author : 寇珊珊
     */
    @Transactional(rollbackFor = {Exception.class})
    public ResponseResultVO<?> saleOrderHandleOutbound(OutboundVO outboundVO) {
        //region 根据id查询 此条入库单的数据还未更改前的数据
        OutboundResponse outboundResponse = outboundMapper.selectById(outboundVO.getOutId());
        //endregion

        //region 应收反记账
        if (outboundResponse.getReceivableId() != null) {
            accountService.reverseReceivable(outboundResponse.getOutId(), Constant.InventoryDocCode.OUTBOUND.getTableName());
        }
        //endregion

        //region 编辑明细
        //校验明细
        if (outboundVO.getItemList().size() == 0) {
            throw new BaseBusinessException(ErrorCodeEnum.OUTBOUND_ITEM_NOT_EXIST.getCode(),
                    ErrorCodeEnum.OUTBOUND_ITEM_NOT_EXIST.getMessage());
        }
        for (OutboundItemVO outboundItemVO : outboundVO.getItemList()) {

            //明细根据id查询
            OutboundItemResponse outboundItemResponse = outboundItemMapper.selectById(outboundItemVO.getItemId());

            //region 校验数量是否超出
            if (outboundItemVO.getOutingQty().compareTo(outboundItemResponse.getOutingQty()) > 0) {
                throw new BaseBusinessException(ErrorCodeEnum.CANNOT_EXCEED_THE_QUANTITYIN_THE_WAREHOUSE.getCode(),
                        ErrorCodeEnum.CANNOT_EXCEED_THE_QUANTITYIN_THE_WAREHOUSE.getMessage());
            }
            //endregion

            //region  编辑明细
            if (outboundItemVO.getItemId() != null) {
                outboundItemVO
                        .setOutQty(outboundItemResponse.getOutQty().add(outboundItemVO.getOutingQty()))
                        .setOutAmt(outboundItemResponse.getOutAmt().add(outboundItemVO.getOutingAmt()))
                        .setOutingQty(BigDecimal.ZERO)
                        .setOutingAmt(BigDecimal.ZERO)
                        .setCostPrice(outboundItemVO.getPriceOut())
                        .setCostAmt(outboundItemVO.getOutQty().multiply(outboundItemVO.getPriceOut()).setScale(2, BigDecimal.ROUND_HALF_UP))
                ;
                //出库状态
                String outStatus = this.setOutStatus(outboundItemVO.getOutingQty(), outboundItemVO.getOutQty());
                outboundItemVO.setOutStatus(outStatus);
                //实体转换
                OutboundItem outboundItem = outboundItemConvert.convertToPo(outboundItemVO);
                //修改
                outboundItemMapper.update(outboundItem,
                        new UpdateWrapper<OutboundItem>().lambda()
                                .eq(OutboundItem::getItemId, UUID.fromString(outboundItem.getItemId()))
                );
                //region 将库存需要的参数赋值
                outboundItemVO.setInventoryType(Constant.InventoryType.OUTBOUND.getName());
                outboundItemVO.setInventoryDocCode(Constant.InventoryDocCode.SALE_ORDER.getValue());
                //编辑之前的数
                if (outboundItemResponse.getOutQty().compareTo(BigDecimal.ZERO) > 0) {
                    outboundItemVO.setQtyBeforeUpdate(outboundItemResponse.getOutQty());
                    outboundItemVO.setAmtBeforeUpdate(outboundItemResponse.getOutAmt());
                }
                outboundItemVO.setAddOrEditFlag(true);
                //endregion

            }

            //endregion

            //region  新建明细
            else {
                outboundItemVO
                        .setOutId(outboundItemVO.getOutId())
                        .setOutQty(outboundItemVO.getOutingQty())
                        .setOutAmt(outboundItemVO.getOutingAmt())
                        .setCostPrice(outboundItemVO.getPriceOut())
                        .setCostAmt(outboundItemVO.getOutQty().multiply(outboundItemVO.getPriceOut()).setScale(2, BigDecimal.ROUND_HALF_UP))
                        .setOutType(Constant.OutType.SALE.getName())
                        .setOutingQty(BigDecimal.ZERO)
                        .setOutingAmt(BigDecimal.ZERO)
                ;
                //出库状态
                String outStatus = this.setOutStatus(outboundItemVO.getOutingQty(), outboundItemVO.getOutQty());
                outboundItemVO.setOutStatus(outStatus);
                //实体转换
                OutboundItem outboundItem = outboundItemConvert.convertToPo(outboundItemVO);
                //新建
                outboundItemMapper.insert(outboundItem);
                outboundItemVO.setItemId(outboundItem.getItemId());

                //region 将库存需要的参数赋值
                outboundItemVO.setInventoryType(Constant.InventoryType.OUTBOUND.getName());
                outboundItemVO.setInventoryDocCode(Constant.InventoryDocCode.SALE_ORDER.getValue());
                outboundItemVO.setAddOrEditFlag(true);
                //endregion
            }
            //endregion

            //region  销售订单明细
            if (outboundItemVO.getFromItemId() != null) {
                //根据id查询
                OrderItemResponse orderItemResponse = orderItemMapper.selectById(outboundItemVO.getFromItemId());
                //赋值（这里重写了更新方法，数量在更新方法中有数据库院士数量+本次数量）
                OrderItem orderItem = new OrderItem();
                orderItem.setItemId(outboundItemVO.getFromItemId());
                orderItem.setOutingQty(outboundItemVO.getOutQty().negate());
                orderItem.setOutingAmt(outboundItemVO.getOutAmt().negate());
                orderItem.setOutQty(outboundItemVO.getOutQty());
                orderItem.setOutAmt(outboundItemVO.getOutAmt());
                //出库状态
                String orderOutStatus = this.setOutStatus(orderItemResponse.getOutingQty().subtract(outboundItemVO.getOutQty()),
                        orderItemResponse.getOutQty().add(orderItem.getOutQty()), orderItemResponse.getItemQty());
                orderItem.setOutStatus(orderOutStatus);
                //修改
                int countRow = orderItemMapper.updateById(orderItem);
                //数量超出
                if (countRow == 0) {
                    throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                }
            }
            //endregion

        }
        //endregion

        //region 删除明细
        BigDecimal delOutingQty = BigDecimal.ZERO;
        BigDecimal delOutingAmt = BigDecimal.ZERO;
        BigDecimal delOutQty = BigDecimal.ZERO;
        BigDecimal delOutAmt = BigDecimal.ZERO;
        if (outboundVO.getDeleteItemList() != null && outboundVO.getDeleteItemList().size() > 0) {
            delOutingQty = outboundVO.getDeleteItemList().stream().map(OutboundItemVO::getOutingQty).reduce(BigDecimal.ZERO, BigDecimal::add).setScale(6, BigDecimal.ROUND_HALF_UP);
            delOutingAmt = outboundVO.getDeleteItemList().stream().map(OutboundItemVO::getOutingAmt).reduce(BigDecimal.ZERO, BigDecimal::add).setScale(2, BigDecimal.ROUND_HALF_UP);
            delOutQty = outboundVO.getDeleteItemList().stream().map(OutboundItemVO::getOutQty).reduce(BigDecimal.ZERO, BigDecimal::add).setScale(6, BigDecimal.ROUND_HALF_UP);
            delOutAmt = outboundVO.getDeleteItemList().stream().map(OutboundItemVO::getOutAmt).reduce(BigDecimal.ZERO, BigDecimal::add).setScale(2, BigDecimal.ROUND_HALF_UP);
            for (OutboundItemVO outboundItemVO : outboundVO.getDeleteItemList()) {
                if (outboundItemVO.getItemId() != null) {

                    //region 将库存需要的参数赋值
                    outboundItemVO.setInventoryType(Constant.InventoryType.OUTBOUND.getName());
                    outboundItemVO.setInventoryDocCode(Constant.InventoryDocCode.SALE_ORDER.getValue());
                    //endregion

                    OutboundItem outboundItem = outboundItemConvert.convertToPo(outboundItemVO);
                    outboundItem.setFlgValid(false);
                    //修改
                    outboundItemMapper.update(outboundItem,
                            new UpdateWrapper<OutboundItem>().lambda()
                                    .eq(OutboundItem::getItemId, UUID.fromString(outboundItem.getItemId()))
                    );
                }
                //region  销售订单明细
                if (outboundItemVO.getFromItemId() != null) {
                    //根据id查询
                    OrderItemResponse orderItemResponse = orderItemMapper.selectById(outboundItemVO.getFromItemId());
                    //赋值（这里重写了更新方法，数量在更新方法中有数据库院士数量+本次数量）
                    OrderItem orderItem = new OrderItem();
                    orderItem.setItemId(outboundItemVO.getFromItemId());
                    orderItem.setOutingQty(outboundItemVO.getOutingQty().negate());
                    orderItem.setOutingAmt(outboundItemVO.getOutingAmt().negate());
                    orderItem.setOutQty(outboundItemVO.getOutQty().negate());
                    orderItem.setOutAmt(outboundItemVO.getOutAmt().negate());
                    //出库状态
                    String outStatus = this.setOutStatus(orderItemResponse.getOutingQty().subtract(orderItem.getOutingQty()),
                            orderItemResponse.getOutQty().add(orderItem.getOutQty()), orderItemResponse.getItemQty());
                    orderItem.setOutStatus(outStatus);
                    //修改
                    int countRow = orderItemMapper.updateById(orderItem);
                    //数量超出
                    if (countRow == 0) {
                        throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                    }
                }
                //endregion
            }
        }
        //endregion

        //region 编辑总单
        BigDecimal sumOutQty = outboundVO.getItemList().stream().map(OutboundItemVO::getOutQty).reduce(BigDecimal.ZERO, BigDecimal::add).setScale(6, BigDecimal.ROUND_HALF_UP);
        BigDecimal sumOutAmt = outboundVO.getItemList().stream().map(OutboundItemVO::getOutAmt).reduce(BigDecimal.ZERO, BigDecimal::add).setScale(2, BigDecimal.ROUND_HALF_UP);
        outboundVO.setOutQty(sumOutQty);
        outboundVO.setOutAmt(sumOutAmt);
        outboundVO.setOutingQty(BigDecimal.ZERO);
        outboundVO.setOutingAmt(BigDecimal.ZERO);
        //出库状态
        String outStatus = this.setOutStatus(outboundVO.getOutingQty(), outboundVO.getOutQty());
        outboundVO.setOutStatus(outStatus);
        //实体转换
        Outbound outbound = outboundConvert.convertToPo(outboundVO);
        //修改
        outboundMapper.update(outbound,
                new UpdateWrapper<Outbound>().lambda()
                        .eq(Outbound::getOutId, UUID.fromString(outbound.getOutId()))
        );
        //endregion

        //region  修改销售订单订单
        if (outboundVO.getFromId() != null) {
            //根据id查询
            OrderResponse orderResponse = orderMapper.selectById(outboundVO.getFromId());
            //赋值（这里重写了更新方法，数量在更新方法中有数据库院士数量+本次数量）
            Order order = new Order();
            order.setOrderId(outboundVO.getFromId());
            order.setOutQty(sumOutQty.subtract(delOutQty));
            order.setOutAmt(sumOutAmt.subtract(delOutAmt));
            order.setOutingQty((outboundResponse.getOutingQty().add(delOutingQty)).negate());
            order.setOutingAmt((outboundResponse.getOutingAmt().add(delOutingAmt)).negate());
            //出库状态
            String orderOutStatus = this.setOutStatus(orderResponse.getOutingQty().subtract(sumOutQty).add(delOutQty),
                    orderResponse.getOutQty().add(order.getOutQty()), orderResponse.getSumQuantity());
            order.setOutStatus(orderOutStatus);
            //修改
            int countRow = orderMapper.updateById(order);
            //数量超出
            if (countRow == 0) {
                throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
            }
        }
        //endregion

        //region  应收记账
        accountService.accReceivable(outboundResponse.getOutId(), Constant.InventoryDocCode.OUTBOUND.getTableName());
        //endregion

        //region   调用库存
        Map<String, Object> map = new HashMap<>();
        map.put("outDetail", outboundVO.getItemList());
        map.put("delOutDetail", outboundVO.getDeleteItemList());
        inventoryService.operatingInventoryInformation(map);
        //endregion
        return ResponseResultUtil.success(outboundVO);
    }


    /**
     * @desc : 销售出库撤销
     * @date : 2024/3/7 17:06
     * @author : 寇珊珊
     */
    @Transactional(rollbackFor = {Exception.class})
    public ResponseResultVO<?> saleOrderOutboundCancel(OutboundVO outboundVO) {
        //region 查询出库总单数据信息
        OutboundResponse outboundResponse = outboundMapper.selectById(outboundVO.getOutId());
        //endregion

        //region    应收反记账
        if (outboundResponse.getReceivableId() != null) {
            accountService.reverseReceivable(outboundResponse.getOutId(), Constant.InventoryDocCode.OUTBOUND.getTableName());
        }
        //endregion

        //region 修改订单数据信息
        if (outboundResponse.getFromId() != null) {
            //赋值  （这里重写了更新方法，数量在更新方法中有数据库院士数量+本次数量）
            Order order = new Order();
            order.setOrderId(outboundResponse.getFromId());
            order.setOutingQty(outboundResponse.getOutQty());
            order.setOutingAmt(outboundResponse.getOutAmt());
            order.setOutQty(outboundResponse.getOutQty().negate());
            order.setOutAmt(outboundResponse.getOutAmt().negate());
            //根据id查询
            OrderResponse orderResponse = orderMapper.selectById(outboundResponse.getFromId());
            //出库状态
            String outStatus = this.setOutStatus(orderResponse.getOutingQty().add(order.getOutingQty()),
                    orderResponse.getOutQty().add(order.getOutQty()), orderResponse.getSumQuantity());
            order.setOutStatus(outStatus);
            //修改
            int countRow = orderMapper.updateById(order);
            //数量超出
            if (countRow == 0) {
                throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
            }

        }
        //endregion

        //region 修改总单数据信息
        Outbound outbound = new Outbound();
        outbound.setOutId(outboundResponse.getOutId());
        outbound.setOutDate(null);
        outbound.setOutStatus(Constant.OutStatus.CHUKUZHONG.getName());
        outbound.setOutQty(BigDecimal.ZERO);
        outbound.setOutAmt(BigDecimal.ZERO);
        outbound.setOutingQty(outboundResponse.getOutingQty().add(outboundResponse.getOutQty()));
        outbound.setOutingAmt(outboundResponse.getOutingAmt().add(outboundResponse.getOutAmt()));
        //修改
        outboundMapper.update(outbound,
                new UpdateWrapper<Outbound>().lambda()
                        .eq(Outbound::getOutId, UUID.fromString(outbound.getOutId()))
        );
        //endregion

        //region 明细数据
        //根据总单id查明细
        List<OutboundItemResponse> outboundItemResponseList = outboundItemMapper.selectByCond(new OutboundItemQuery().setOutId(outboundResponse.getOutId()));
        for (OutboundItemResponse outboundItemResponse : outboundItemResponseList) {
            //region 修改销售订单明细数据信息
            if (outboundItemResponse.getFromItemId() != null) {
                //根据id查询
                OrderItemResponse orderItemResponse = orderItemMapper.selectById(outboundItemResponse.getFromItemId());
                //赋值  （这里重写了更新方法，数量在更新方法中有数据库院士数量+本次数量）
                OrderItem orderItem = new OrderItem();
                orderItem.setItemId(outboundItemResponse.getFromItemId());
                orderItem.setOutQty(outboundItemResponse.getOutQty().negate());
                orderItem.setOutAmt(outboundItemResponse.getOutAmt().negate());
                orderItem.setOutingQty(outboundItemResponse.getOutQty());
                orderItem.setOutingAmt(outboundItemResponse.getOutAmt());
                //出库状态
                String outStatus = this.setOutStatus(orderItemResponse.getOutingQty().add(orderItem.getOutingQty()),
                        orderItemResponse.getOutQty().add(orderItem.getOutQty()), orderItemResponse.getItemQty());
                orderItem.setOutStatus(outStatus);
                //修改
                int countRow = orderItemMapper.updateById(orderItem);
                //数量超出
                if (countRow == 0) {
                    throw new BaseBusinessException(ResponseCodeEnum.OPERATE_FAIL.getCode(), ErrorCodeEnum.INVENTORY_QUANTITY_EXCEEDED_OUTBOUND.getMessage());
                }
            }
            //endregion

            //region修改出库明细信息
            OutboundItem outboundItem = new OutboundItem();

            //region 将库存需要的参数赋值
            outboundItemResponse.setInventoryType(Constant.InventoryType.OUTBOUND.getName());
            outboundItemResponse.setInventoryDocCode(Constant.InventoryDocCode.SALE_ORDER.getValue());
            outboundItemResponse.setOutQty(outboundItemResponse.getOutQty().negate());
            outboundItemResponse.setOutQty(outboundItemResponse.getOutQty().negate());
            //endregion

            outboundItem
                    .setOutId(outboundResponse.getOutId())
                    .setOutStatus(Constant.OutStatus.CHUKUZHONG.getName())
                    .setOutingQty(outboundItemResponse.getOutingQty().add(outboundItemResponse.getOutQty()))
                    .setOutAmt(outboundItemResponse.getOutingAmt().add(outboundItemResponse.getOutAmt()))
                    .setOutQty(BigDecimal.ZERO)
                    .setOutAmt(BigDecimal.ZERO)
                    .setCostPrice(BigDecimal.ZERO)
                    .setCostAmt(BigDecimal.ZERO)
                    .setItemId(outboundItemResponse.getItemId());
            //修改
            outboundItemMapper.update(outboundItem,
                    new UpdateWrapper<OutboundItem>().lambda()
                            .eq(OutboundItem::getItemId, UUID.fromString(outboundItem.getItemId()))
            );
            //endregion
        }
        //endregion

        //region   调用库存
        Map<String, Object> map = new HashMap<>();
        map.put("delOutDetail", outboundItemResponseList);
        inventoryService.operatingInventoryInformation(map);
        //endregion

        return ResponseResultUtil.success();
    }

    /**
     * @desc : 出库状态通用（目前本页面）
     * @date : 2024/3/9 8:59
     * @author : 寇珊珊
     */
    @Transactional(rollbackFor = {Exception.class})
    public String setOutStatus(BigDecimal outingQty, BigDecimal outQty) {
        //出库状态
        String outStatus = null;
        //已出库数量>0 出库中数量>0
        if (outQty.compareTo(BigDecimal.ZERO) >= 0 && outingQty.compareTo(BigDecimal.ZERO) > 0) {
            //出库中
            outStatus = Constant.OutStatus.CHUKUZHONG.getName();
        }
        //出入库数量=0 出库中数量=0
        else if (outQty.compareTo(BigDecimal.ZERO) == 0 && outingQty.compareTo(BigDecimal.ZERO) == 0) {
            //待出库
            outStatus = Constant.OutStatus.DAICHUKU.getName();
        }
        //已出库数量>0 出库中数量=0
        else if (outQty.compareTo(BigDecimal.ZERO) > 0 && outingQty.compareTo(BigDecimal.ZERO) == 0) {
            //已出库
            outStatus = Constant.OutStatus.YICHUKU.getName();
        }
        return outStatus;
    }


    /**
     * @desc : 上游单据入库状态通用（目前本页面）
     * @date : 2024/4/1 17:14
     * @author : 寇珊珊
     */
    @Transactional(rollbackFor = {Exception.class})
    public String setOutStatus(BigDecimal intoingQty, BigDecimal intoQty, BigDecimal sumQty) {
        //入库状态
        String outStatus = null;
        //入库中+已入库 小于 总数
        if (intoingQty.add(intoQty).compareTo(sumQty) < 0) {
            //入库中
            outStatus =Constant.OutStatus.CHUKUZHONG.getName();
        }
        //已入库数量=0 入库中数量=0
        else if (intoQty.compareTo(BigDecimal.ZERO) == 0 && intoingQty.compareTo(BigDecimal.ZERO) == 0) {
            //待入库
            outStatus =  Constant.OutStatus.DAICHUKU.getName();
        }
        //入库中+已入库 等于 总数
        else if (intoingQty.add(intoQty).compareTo(sumQty) == 0) {
            //已入库
            outStatus =  Constant.OutStatus.YICHUKU.getName();
        }
        return outStatus;
    }


    /**
     * @desc : 获取单据信息（编辑用）
     * @date : 2024/3/16 16:28
     * @author : 寇珊珊
     */
    public ResponseResultVO<?> selectByUpdate(String id) {
        Map<String, Object> dataInfo = new HashMap<>();
        //总单
        OutboundResponse outboundResponse = outboundMapper.selectMessageByOtherQuery(new OutboundQuery().setOutId(id).setOutStatus(Constant.OutStatus.CHUKUZHONG.getName()));
        //单据不存在
        if (outboundResponse == null) {
            throw new BaseBusinessException(ErrorCodeEnum.THERE_ORDER_IS_NOT_CAN_OUTBOUND_QUANTITY.getCode(),
                    ErrorCodeEnum.THERE_ORDER_IS_NOT_CAN_OUTBOUND_QUANTITY.getMessage());
        }
        dataInfo.put("data", outboundResponse);
        // 明细
        List<OutboundItemResponse> outboundItemResponseList = outboundItemMapper.selectByCond(new OutboundItemQuery().setOutId(outboundResponse.getOutId()));
        dataInfo.put("dataItem", outboundItemResponseList);
        return ResponseResultUtil.success(dataInfo);
    }

    /********************************************** 销售出库查询相关方法begin *************************************/
    /**
     * @desc : 一览页销售出库
     * @author : 付斌
     * @date : 2023/1/9 10:40
     */
    @Pagination
    public ResponseResultVO<PageList<OutboundResponse>> selectByCond(OutboundQuery outboundQuery) {
        outboundQuery.setOutType(Constant.OutType.SALE.getName());
        return super.mergeListWithCount(outboundQuery, outboundMapper.selectByCond(outboundQuery),
                outboundMapper.countByCond(outboundQuery));
    }

    /**
     * @desc : 一览页销售出库明细（货物、附件）
     * @author : 付斌
     * @date : 2024-02-28 13:25
     */
    @Pagination
    public ResponseResultVO<Map<String, Object>> selectOutboundInfoById(String id) {
        Map<String, Object> result = new HashMap<>();
        // 商品明细
        List<OutboundItemResponse> outboundItem = outboundItemMapper.selectByCond(new OutboundItemQuery().setOutId(id));
        result.put("outboundItem", outboundItem);

        // 附件
        return ResponseResultUtil.success(result);
    }

    /**
     * @desc : 获取销售出库信息（编辑用）
     * @author : 付斌
     * @date : 2024-03-02 17:27
     */
    public ResponseResultVO<?> getOutboundForUpdate(String id) {
        Map<String, Object> dataInfo = new HashMap<>();
        OutboundResponse outboundResponse = outboundMapper.selectById(id);
        dataInfo.put("data", outboundResponse);

        // 商品明细
        List<OutboundItemResponse> outboundItemResponseList = outboundItemMapper.selectByCondForOutEdit(id);
        dataInfo.put("dataItem", outboundItemResponseList);
        return ResponseResultUtil.success(dataInfo);
    }

    /**
     * @desc : 获取销售出库信息（编辑用，适用于直接新建的出库单）
     * @author : 付斌
     * @date : 2024-03-02 17:27
     */
    public ResponseResultVO<?> getOutboundTogetherForUpdate(String id) {
        Map<String, Object> dataInfo = new HashMap<>();
        OutboundResponse outboundResponse = outboundMapper.selectById(id);
        dataInfo.put("data", outboundResponse);

        // 商品明细
        List<OutboundItemResponse> outboundItemResponseList = outboundItemMapper.selectByCondForOutEditTogether(id);
        dataInfo.put("dataItem", outboundItemResponseList);
        return ResponseResultUtil.success(dataInfo);
    }

    /**
     * @desc : 获取出库信息（新建退货用）
     * @author : 付斌
     * @date : 2024-03-02 17:27
     */
    public ResponseResultVO<?> getOutForReturn(String id) {
        OutboundResponse outboundResponse = outboundMapper.selectByIdForReturn(id);
        List<OutboundItemResponse> outboundItemList = outboundItemMapper.selectByCondForReturn(new OutboundItemQuery().setOutId(id));

        if(outboundItemList != null && outboundItemList.size() > 0){
            // 求和
            OutboundItemResponse sumEntity = outboundItemList.stream().reduce((x, y) -> {
                OutboundItemResponse item = new OutboundItemResponse();
                item.setOutingQty(x.getOutingQty().add(y.getOutingQty()));
                item.setOutingAmt(x.getOutingAmt().add(y.getOutingAmt()));
                return item;
            }).get();
            outboundResponse.setOutingQty(sumEntity.getOutingQty()).setOutingAmt(sumEntity.getOutingAmt());
        }

        Map<String, Object> dataInfo = new HashMap<>();
        dataInfo.put("data", outboundResponse);
        dataInfo.put("dataItem", outboundItemList);

        return ResponseResultUtil.success(dataInfo);
    }

    /**
     * @desc : 查询出库明细（货物、附件）
     * @author : 付斌
     * @date : 2024-02-28 13:25
     */
    @Pagination
    public ResponseResultVO selectById(String id) {

        OutboundResponse outboundResponse = outboundMapper.selectById(id);
        // 商品明细
        List<OutboundItemResponse> outboundItem = outboundItemMapper.selectByCond(new OutboundItemQuery().setOutId(id));
        outboundResponse.setGoodsList(outboundItem);

        // 附件
        return ResponseResultUtil.success(outboundResponse);
    }
    /********************************************** 销售出库查询相关方法end *************************************/

//    /**
//     * @desc : 条件查询
//     * @date : 2024/3/18 11:20
//     * @author : 寇珊珊
//     */
//    @Pagination
//    public ResponseResultVO<PageList<InboundResponse>> selectByCond(OutboundQuery outboundQuery) {
//        return super.mergeListWithCount(outboundQuery, outboundMapper.selectByCond(outboundQuery),
//                outboundMapper.countByCond(outboundQuery));
//    }
//
//    /**
//     * @desc : 查询明细
//     * @date : 2024/3/15 16:43
//     * @author : 寇珊珊
//     */
//    @Pagination
//    public ResponseResultVO<Map<String, Object>> selectOutBoundSaleOrderItemInfoById(String id) {
//        Map<String, Object> result = new HashMap<>();
//        // 商品明细
//        List<OutboundItemResponse> outboundItemResponseList = outboundItemMapper.selectByCond(new OutboundItemQuery().setOutId(id));
//        result.put("itemList", outboundItemResponseList);
//        // 收款
//
//        // 附件
//        return ResponseResultUtil.success(result);
//    }

    /**
     * @desc : 条件查询(总单带明细)
     * @author : 于继渤
     * @date : 2023/1/9 10:36
     */
    @Pagination
    public ResponseResultVO<PageList<OutboundResponse>> selectByCondDetail(OutboundQuery outboundQuery) {
        return super.mergeListWithCount(outboundQuery, outboundMapper.selectByCondDetail(outboundQuery),
                outboundMapper.countByCondDetail(outboundQuery));
    }

}
